let dbms = createDB "SampleDatabase";;
let dbms = createTable dbms "Student";;
let dbms = createTable dbms "Grade";;
let dbms = createTable dbms "DumpIt";;
let dbms = dropTable dbms "DumpIt";;
let dbms = addColumnToTable dbms "Student" {defcolname="LastName"; coltype= CHAR 30};;
let dbms = addColumnToTable dbms "Student" {defcolname="FirstName"; coltype= CHAR 30};;
let dbms = addColumnToTable dbms "Grade" {defcolname="LastName"; coltype= CHAR 30};;
let dbms = addColumnToTable dbms "Grade" {defcolname="Score"; coltype= INT};;

let dbms = addDataRowToTable dbms "Student"  { data = [
          {datacolname = "LastName"; value = Char "Smith"};
          {datacolname = "FirstName"; value = Char "Joe"} 
          ]};;

let dbms = addDataRowToTable dbms "Student"  { data = [
          {datacolname = "LastName"; value = Char "Smith"};
          {datacolname = "FirstName"; value = Char "Tubby"} 
          ]};;

          
let dbms = addDataRowToTable dbms "Student"  { data = [
          {datacolname = "LastName"; value = Char "Doe"};
          {datacolname = "FirstName"; value = Char "Jane"} 
          ]};;          
          

let dbms = addDataRowToTable dbms "Grade"  { data = [
          {datacolname = "LastName"; value = Char "Smith"};
          {datacolname = "Score"; value = Int 88} 
          ]};;
          
let dbms = addDataRowToTable dbms "Grade"  { data = [
          {datacolname = "LastName"; value = Char "Doe"};
          {datacolname = "Score"; value = Int 94} 
          ]};;          

printTable dbms "Student";;          
printTable dbms "Grade";;

(* Is Smith *)
let avalue = {datacolname = "LastName"; value = Char "Smith"};;
let predicate = { preddata = avalue; predoper = OpEq };;
let filteredRowlist = filterrowdatalist predicate (getTable dbms.tablelist "Student").rowdatalist;;
printRowslist  (getTable dbms.tablelist "Student").coldeflist filteredRowlist;;


(* Is NOT Smith *)
let avalue = {datacolname = "LastName"; value = Char "Smith"};;
let predicate = { preddata = avalue; predoper = OpNe };;
let filteredRowlist = filterrowdatalist predicate (getTable dbms.tablelist "Student").rowdatalist;;
printRowslist  (getTable dbms.tablelist "Student").coldeflist filteredRowlist;;

(* Is NOT Doe *)
let avalue = {datacolname = "LastName"; value = Char "Doe"};;
let predicate = { preddata = avalue; predoper = OpNe };;
let filteredRowlist = filterrowdatalist predicate (getTable dbms.tablelist "Student").rowdatalist;;
printRowslist  (getTable dbms.tablelist "Student").coldeflist filteredRowlist;;


(* DELETE - Tubby *)
let avalue = {datacolname = "FirstName"; value = Char "Tubby"};;
(* NOTE: we want everyone except Tubby *)
let predicate = { preddata = avalue; predoper = OpEq };;
let dbms = deleterow dbms predicate "Student";;
printTable dbms "Student";;          


(* UPDATE *)
let predvalue = {datacolname = "FirstName"; value = Char "Jane"};;
let predicate = { preddata = predvalue; predoper = OpEq };;
let values = [{datacolname = "LastName"; value = Char "Dog"}];;
let dbms = updaterows dbms "Student" predicate values;;
printTable dbms "Student";;     


(* SUM *)
let dbms = aggregate dbms "Grade" "Score" Sum;;
let dbms = aggregate dbms "Grade" "Score" Avg;;

